/*--------------------------------------------------------------------------------------------
	1_rendezes.c

*/

#include <stdio.h>
#include <stdlib.h>

#define TOMBMERET 100
#define LADAMERET 50
	
int tarolo[TOMBMERET];  			/*a rendezend tmb*/
int segedtarolo[TOMBMERET];
int fesulendo1[50],fesulendo2[50];		/*a kt sszefslend tmb*/	
int i,j;						

/*--------------------------------------------------------------------------------------------
	a tmbt tlti fel fordtott sorrendben
*/
void feltolt()
{
	int j=100;
	for(i=0; i<TOMBMERET; i++)
	{
		tarolo[i]=j;
		j--;
	}							
} 
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	a tmbt tlti fel a ldarendezshez (0..49 szmokkal)
*/
void feltolt2()
{
	int j=99;
	for(i=0; i<TOMBMERET; i++)
	{
		tarolo[i]=j/2;
		j--;
	}							
} 
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	kt tmbt tlt fel az sszefslshez
*/
void feltolt3()
{
	int j=0;
	for(i=0; i<50; i++)
	{
		fesulendo1[i]=j;
		j+=2;
	}	

	j=1;
	for(i=0; i<50; i++)
	{
		fesulendo2[i]=j;
		j+=2;
	}						
} 
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	tmbt tlt fel az sszefslshez
*/
void feltolt4()
{
	int j=0;
	for(i=0; i<50; i++)
	{
		tarolo[i]=j;
		j+=2;
	}	

	j=1;
	for(i=50; i<100; i++)
	{
		tarolo[i]=j;
		j+=2;
	}						
} 
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	kt tmbt tlt fel az sszefslshez
*/
void feltolt5()
{
	int j=0;
	for(i=49; i>-1; i--)
	{
		tarolo[i]=j;
		j+=2;
	}	

	j=1;
	for(i=99; i>49; i--)
	{
		tarolo[i]=j;
		j+=2;
	}						
} 
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	kirja a tarolo tmb tartalmt
*/
void kiir()
{
	for(i=0; i<TOMBMERET; i++)
	{
		printf("%d, ", tarolo[i]);
	}
	printf("\n\n");
}
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	kirja a fesulendo1 s a fesulendo2 tmb tartalmt
*/
void kiir3()
{
	for(i=0; i<50; i++)
	{
		printf("%d, ", fesulendo1[i]);
	}
	printf("\n");

	for(i=0; i<50; i++)
	{
		printf("%d, ", fesulendo2[i]);
	}
	printf("\n\n");
}
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	BESzRSOS rendezs (lineris keresssel)
*/
int beszurlinearis()
{
	int atmeneti;			        		/*tmeneti trol*/
	int i,j,h;

	for(j=1; j<TOMBMERET; j++)
	{
								
		i=0;
		while((i<j) && (tarolo[i] < tarolo[j])) i++;	/*lineris kereses a mr rendezett rszben*/
			
		h=j;
		atmeneti=tarolo[h];				/*j elem kimsolsa*/
		while (i<h)					/*az elemek elcssztatsa*/
		{
			tarolo[h]=tarolo[h-1];
			h--;
		}
		tarolo[h]=atmeneti;				/*j elem beszrsa*/
		
	}
	
	return 0;						/*visszatrs*/
}
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	BESZURASOS rendezs (binris keresessel)
*/
int beszurbinaris()
{
	int atmeneti;			          		/*tmeneti trol*/
	int j,h;
	int also,felso,kozepso;

	for(j=1; j<TOMBMERET; j++)
	{
								/*binris kereses a mr rendezett rszben*/
		also=0;       					/*als hatr*/
		felso=j;       					/*fels hatr*/
		kozepso=0;    					/*kzps*/

		while(also<felso+1)
		{
			kozepso=(also+felso)/2;
			if (tarolo[j] >= tarolo[kozepso])
				also=kozepso+1;
			else
				felso=kozepso-1;
		}
			
		h=j;
		atmeneti=tarolo[h];				/*j elem kimsolsa*/
		while (also<h)					/*az elemek elcssztatsa*/
		{
			tarolo[h]=tarolo[h-1];
			h--;
		}
		tarolo[h]=atmeneti;				/*j elem beszrsa*/
	}
	
	return 0;						/*visszatrs*/
}
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	BUBOREK rendezes 
*/

int buborek()
{
	int atmeneti;                    			/*tmeneti trol*/
	int j=0, i;

	for(j=TOMBMERET-2; j>=0; j--)				/*kls for ciklus*/
	{
		for(i=0; i<=j; i++)				/*bels for ciklus*/
		{
			if (tarolo[i+1] < tarolo[i])		/*szomszdos elemek vizsglata*/	
			{					/*szomszdos elemek cserje*/
				atmeneti = tarolo[i];		
				tarolo[i] = tarolo[i+1];
				tarolo[i+1] = atmeneti;
			}
		}
	}
	
	return 0;						/*visszatrs*/
}
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	Gyorsrendezs segdfggvnye
	a tnyleges rendezest ez a fggvny vgzi
*/

void felosztas(int eleje, int vege)
{
	int bal=eleje;   					/*az intervallum als hatra*/
	int jobb=vege;    					/*az intervallum fels hatra*/
	int atmeneti;         					/*tmeneti trol*/
	int alap=tarolo[(eleje+vege)/2];  			/*alapelem kivlasztsa*/

	do
	{	
		while (tarolo[bal] < alap) bal++;		/*keress balrl*/
		while (tarolo[jobb] > alap) jobb--;		/*keress jobbrl*/

		if (bal <= jobb)				//sszertnk-e mr*/
		{						/*ha nem akkor csere*/
			atmeneti = tarolo[bal];
			tarolo[bal] = tarolo[jobb];
			tarolo[jobb] = atmeneti;
			bal++;					/*kvetkeznl folytatdik*/
			jobb--;		
		}

	} while(bal < jobb);
	
	if (eleje < jobb) felosztas(eleje, jobb);		/*bal rsz rendezse*/	
	if (bal < vege) felosztas(bal, vege);			/*jobb rsz rendezse*/
}


/*--------------------------------------------------------------------------------------------
	Gyorsrendezs (QuickSort)
*/

int gyorsrendezes()
{
	felosztas(0, TOMBMERET-1); 				/*segdfggvny hvsa*/
	return 0;						/*visszatrs*/
}
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	Ldarendezs - egy segdtmbt hasznl az elfordul szmok sszeszmolshoz
*/

int ladarendezes()
{
	int lada[LADAMERET]; 					/*benne troljuk hogy melyik szm hnyszor fordult el*/
	int index,i;

	for( i=0; i<LADAMERET; i++) lada[i]=0;			/*kezdeti rtk belltsa 0-ra*/
	for( i=0; i<TOMBMERET; i++) lada[tarolo[i]]++;		/*megszmoljuk, hogy melyik szm hnyszor fordul el*/

	index=0;						/*a szmols alapjn rendezetten feltltjk a tarolo-t*/
	for( i=0; i<LADAMERET; i++)
	{
		while(lada[i]-- > 0)				/*amg van a ldban*/
		{
			tarolo[index++]=i;			/*a rendezend tmbe rs*/
		}
	}

	return 0;						/*visszatrs*/
}
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	kt tmb sszefslst vgezi ( fesulendo1, fesulendo2 elemei fsldnek a tarolo tmmbe)
*/

int osszefesul()
{
	int f1=0, f2=0;						/*azt mutatjk, hogy melyik tmben meddig jutottunk a fslssel*/
	
	i=0;
	while((f1<50) || (f2<50))				/*az szefsl ciklus*/
	{
		if( ((fesulendo1[f1] < fesulendo2[f2]) && (f1<50)) || (f2==50))		/*megnzzk, hogy melyik elem lesz a kvetkez az j tmbben*/
		{
			tarolo[i] = fesulendo1[f1];		/*ha a fesulendo1 tmb kvetkez eleme a kisebb*/
			f1++;
		}
		else						/*ha a fesulendo2 tmb kvetkez eleme a kisebb vagy egyenl*/
		{
			tarolo[i] = fesulendo2[f2];
			f2++;
		}
		i++;
	}
	
	return 0;						/*visszatrs*/	
}
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	a tarolo tmb kt kijellt rsznek az sszefslst vgzi,  az osszefesuleses_rendezes segedfuggvenye
*/

int osszefesules(int also1, int felso1, int also2, int felso2)
{
	int f1=also1, f2=also2;						/*azt mutatjk, hogy melyik tmbben meddig jutottunk a fslssel*/
	int segedindex=0;
	
	while((f1<=felso1) || (f2<=felso2))				/*az szefsl ciklus*/
	{
		if( ((tarolo[f1] < tarolo[f2]) && (f1<=felso1)) || (f2==felso2+1))		/*megnzzk, hogy melyik elem lesz a kvetkez az j tmbben*/
		{
			segedtarolo[segedindex] = tarolo[f1];		/*ha az els rsztmb kvetkez eleme a kisebb*/
			f1++;
		}
		else							/*ha a msodik rsztmb kvetkez eleme a kisebb vagy egyenl*/
		{
			segedtarolo[segedindex] = tarolo[f2];
			f2++;
		}
		segedindex++;
	}

	for(i=also1; i<=felso2; i++)					/*visszamasoljuk a tarolo tombbe az elemeket*/
	{
		tarolo[i]=segedtarolo[i-also1];
	}
	
	return 0;							/*visszatrs*/		
}
/*--------------------------------------------------------------------------------------------
*/


/*--------------------------------------------------------------------------------------------
	osszefesuleses rendezest vegez
*/
int osszefesuleses_rendezes(int eleje, int vege)
{
	int kozepe;
	if(eleje==vege) return 0;					/*megnezzuk, hogy lecsokkent-e 1 elemre a rsztmb*/
	else								/*ha nem rendeznk tovbb*/
	{
		kozepe=(eleje+vege)/2;					/*kzps elem kivlasztsa*/
		osszefesuleses_rendezes(eleje, kozepe);			/*a tmb els felnek a rendezse*/
		osszefesuleses_rendezes(kozepe+1, vege);		/*a tmb msodik felnek a rendezse*/
		osszefesules(eleje, kozepe, kozepe+1, vege);		/*kt fltmb sszefslse*/
	}

	return 0;							/*visszatrs*/		
}
/*--------------------------------------------------------------------------------------------
*/


void main()
{
	
	feltolt();	kiir();		beszurlinearis();	kiir();
	feltolt();	kiir();		beszurbinaris();	kiir();
	feltolt();	kiir();		buborek();		kiir();
	feltolt();	kiir();		gyorsrendezes();	kiir();
	feltolt2();	kiir(); 	ladarendezes();		kiir();
	feltolt3(); 	kiir3(); 	osszefesul();		kiir();
	feltolt5(); 	kiir(); 	osszefesuleses_rendezes(0, TOMBMERET-1);		kiir();

	
}
