/*--------------------------------------------------------------------------------------------
	3_matrix.cpp

*/

#include <stdio.h>
#include <stdlib.h>

int matrixA[4][4]={1,2,3,1,0,0,1,2,1,1,1,2,3,2,0,1};
int matrixB[4][4]={2,1,2,3,2,0,2,1,1,0,3,2,1,1,2,0};
int matrixC[4][4]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

double C[3][3]={2,1,2,3,2,0,1,3,1};
double adjC[3][3];
double invC[3][3];

int i,j,k;		


/*--------------------------------------------------------------------------------------------
	a 4x4-es mtrixot rja ki
*/
void kiir(int M[4][4])
{
	for (i=0;i<4;i++)					/*els for ciklus*/
	{
		for(j=0;j<4;j++)				/*msodik for ciklus*/
		{
			printf("%d\t", M[i][j]);		/*kiirs*/
		}
		printf("\n");
	}	
}
/*--------------------------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------------------------
	a 3x3-as mtrixot rja ki
*/
void kiir2(double M[3][3])
{
	for (i=0;i<3;i++)					/*els for ciklus*/
	{
		for(j=0;j<3;j++)				/*msodik for ciklus*/
		{
			printf("%lf\t", M[i][j]);		/*kiirs*/
		}
		printf("\n");
	}	
}
/*--------------------------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------------------------
	kt mtrixot ad ssze
*/
void matrix_osszeadas(int A[4][4], int B[4][4], int C[4][4])
{
	for (i=0;i<4;i++)					/*els for ciklus*/
	{
		for(j=0;j<4;j++)				/*msodik for ciklus*/
		{
			C[i][j] = A[i][j] + B[i][j];		/*sszeads elvgzse*/
		}
	}	
}
/*--------------------------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------------------------
	kt mtrixot szoroz ssze
*/
void matrix_szorzas(int A[4][4], int B[4][4], int C[4][4])
{
	for (i=0;i<4;i++)					/*az erdmnymtrixot trli, nullzza*/
	{							/*els for ciklus*/
		for(j=0;j<4;j++)				/*msodik for ciklus*/
		{
			C[i][j] = 0;				/*rtkads*/
		}
	}	
	

	for (i=0;i<4;i++)					/*els for ciklus 	- a ciklusvltoz a sort jelli*/
	{
		for(j=0;j<4;j++)				/*msodik for ciklus	- a ciklusvltoz az oszlopot jelli*/
		{
			for(k=0;k<4;k++)			/*harmadik for ciklus*/
			{
				C[i][j] += A[i][k] * B[k][j];	/*szorzs elvgzse*/
			}
		}
	}	
}
/*--------------------------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------------------------
	msodrend determinnst szmol ki
*/
double masodr_det(double c11, double c12, double c21, double c22)
{	
	return c11*c22-c12*c21;
}
/*--------------------------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------------------------
	harmadrend determinnst szmol ki
*/
double harmadr_det(double C[3][3])
{	
	return C[0][0]*masodr_det(C[1][1],C[1][2],C[2][1],C[2][2])-C[1][0]*masodr_det(C[0][1],C[0][2],C[2][1],C[2][2])+C[2][0]*masodr_det(C[0][1],C[0][2],C[1][1],C[1][2]);
}
/*--------------------------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------------------------
	3x3-as mtrixot transponl
*/
void transzponal(double C[3][3])
{	
	double atmeneti;
	for (i=0;i<3;i++)					/*els for ciklus*/
	{
		for(j=i+1;j<3;j++)				/*msodik for ciklus*/
		{
								/*a ftl feletti elemekre*/
			atmeneti = C[i][j];			/*kicserljk a kt elemet*/
			C[i][j] = C[j][i];
			C[j][i] = atmeneti;			
		}
		
	}	
}
/*--------------------------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------------------------
	3x3-as mtrixot adjungl
*/
void adjungal(double C[3][3], double adjC[3][3])
{	
	adjC[0][0]=C[1][1]*C[2][2]-C[1][2]*C[2][1];		/*kiszmoljuk az elemekhez tartoz aldeterminnsok rtkt*/
	adjC[0][1]=(-1)*(C[1][0]*C[2][2]-C[1][2]*C[2][0]);
	adjC[0][2]=C[1][0]*C[2][1]-C[1][1]*C[2][0];
	adjC[1][0]=(-1)*(C[0][1]*C[2][2]-C[0][2]*C[2][1]);
	adjC[1][1]=C[0][0]*C[2][2]-C[0][2]*C[2][0];
	adjC[1][2]=(-1)*(C[0][0]*C[2][1]-C[0][1]*C[2][0]);
	adjC[2][0]=C[0][1]*C[1][2]-C[0][2]*C[1][1];
	adjC[2][1]=(-1)*(C[0][0]*C[1][2]-C[0][2]*C[1][0]);
	adjC[2][2]=C[0][0]*C[1][1]-C[0][1]*C[1][0];

	transzponal(adjC);					/*elvgezzk a transzponlst*/
}
/*--------------------------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------------------------
	3x3-as mtrix invezt szmolja ki
*/
void inverz(double C[3][3], double invC[3][3])
{	
	double detC = harmadr_det(C);				/*kiszmoljuk a determinnst*/
	adjungal(C, invC); 					/*meghatrozzuk az adjunglt mtrixot*/
	
	for (i=0;i<3;i++)					/*els for ciklus*/
	{
		for(j=0;j<3;j++)				/*msodik for ciklus*/
		{
			invC[i][j] = invC[i][j] / detC;		/*a mtrix elemeit elosztjuk a determinns rtkvel*/			
		}
		
	}	
}
/*--------------------------------------------------------------------------------------------*/


main()
{

	/* mtrixok sszeadsa*/
	printf("Mtrix A:\n");
	kiir(matrixA);
	printf("\n\n");
	printf("Mtrix B:\n");
	kiir(matrixB);
	printf("\n\n");
	printf("Mtrix C:\n");
	kiir(matrixC);
	printf("\n\n");
	matrix_osszeadas(matrixA, matrixB, matrixC);
	printf("Eredmny mtrix C:\n");
	kiir(matrixC);
	


	/* mtrixok szorzsa*/
	printf("Mtrix A:\n");
	kiir(matrixA);
	printf("\n\n");
	printf("Mtrix B:\n");
	kiir(matrixB);
	printf("\n\n");
	matrix_szorzas(matrixA, matrixB, matrixC);
	printf("Eredmny mtrix C:\n");
	kiir(matrixC);


	/*msodrend determinns rtke*/
	printf("%lf\n", masodr_det(2,1,2,3));


	/*harmadrend determinns rtke*/
	printf("%lf\n", harmadr_det(C));



	/*3x3-as mtrix transzponltja*/
	printf("A mtrix:\n");
	kiir2(C); 
	transzponal(C); 
	printf("A mtrix transzponltja:\n");
	kiir2(C);	



	/*3x3-as mtrix adjungltja*/
	printf("A mtrix:\n");
	kiir2(C); 
	adjungal(C, adjC); 
	printf("A mtrix adjungltja:\n");
	kiir2(adjC);
	

	/*3x3-as mtrix inverze*/
	printf("A mtrix:\n");
	kiir2(C); 
	inverz(C, invC); 
	printf("A mtrix inverze:\n");
	kiir2(invC);


return 0;
}
