/*--------------------------------------------------------------------------------------------
	4_graf.c

*/

#include <stdio.h>
#include <stdlib.h>

struct binaris{					/*a binaris fa egy elemt tartalamaz struktura*/
	int szamozas;				/*sorszm amit a bejrskor kap*/
	int tartalom;				/*rdemleges tartalom*/
	struct binaris *szulo;			/*mutato a szlre*/
	struct binaris *bal;			/*mutat a bal gyerekre*/
	struct binaris *jobb;			/*mutat a jobb gyerekre*/
};
	

struct listaelem{
	int sorszam;				/*ez a sorszmaot tartalmazza*/
	struct binaris *elem;			/*a binris fa elemre mutat*/
	struct listaelem *kov;			/*a lncolt lista kvetkez elemre mutat*/
};

struct binaris *gyoker=NULL, *ketto, *harom, *negy, *ot, *hat, *het, *nyolc; 
struct binaris* seged=NULL;
struct listaelem *elso=NULL, *utolso=NULL, *aktualis=NULL;

int i,kovetkezo=1,kiosztott=1;						

/*--------------------------------------------------------------------------------------------
	binris ft kszt
*/
void feltolt()
{
	gyoker= (struct binaris *)malloc(sizeof(struct binaris));
	if(!gyoker)
	{
		printf("\Kevs a memria!\n");
		/*/return -1;  */
	}	
	ketto= (struct binaris *)malloc(sizeof(struct binaris));
	harom= (struct binaris *)malloc(sizeof(struct binaris));
	negy= (struct binaris *)malloc(sizeof(struct binaris));
	ot= (struct binaris *)malloc(sizeof(struct binaris));
	hat= (struct binaris *)malloc(sizeof(struct binaris));
	het= (struct binaris *)malloc(sizeof(struct binaris));
	nyolc= (struct binaris *)malloc(sizeof(struct binaris));
	gyoker->szamozas=1; gyoker->tartalom=1;	gyoker->szulo=NULL; gyoker->bal=ketto; gyoker->jobb=harom;
	ketto->szamozas=0; ketto->tartalom=2;	ketto->szulo=gyoker; ketto->bal=negy; ketto->jobb=ot;
	harom->szamozas=0; harom->tartalom=3;	harom->szulo=gyoker; harom->bal=NULL; harom->jobb=nyolc;
	negy->szamozas=0; negy->tartalom=4;	negy->szulo=ketto; negy->bal=NULL; negy->jobb=NULL;
	ot->szamozas=0; ot->tartalom=5;	ot->szulo=ketto; ot->bal=hat; ot->jobb=het;
	hat->szamozas=0; hat->tartalom=6;	hat->szulo=ot; hat->bal=NULL; hat->jobb=NULL;
	het->szamozas=0; het->tartalom=7;	het->szulo=ot; het->bal=NULL; het->jobb=NULL;	
	nyolc->szamozas=0; nyolc->tartalom=8;	nyolc->szulo=harom; nyolc->bal=NULL; nyolc->jobb=NULL;				
} 
/*--------------------------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------------------------
	binris ft kiir
*/
int kiir(struct binaris *gy)
{
	printf("\n%d\t%d\n",gy->szamozas,gy->tartalom);
	if (gy->bal) kiir(gy->bal);
	if (gy->jobb) kiir(gy->jobb);
	return 0;
} 
/*--------------------------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------------------------
	szlessgi bejaras
*/
int szelessegi_bejaras(struct binaris *m)
{
	aktualis = elso->kov;						/*kivesszk a sorbl az els elemet, mert ennek a gyerekeit most jarjuk be*/
	elso->kov = aktualis->kov;		
	if (elso == elso->kov) utolso=elso;				/*ha kirl a lncolt lista, s csak a strzsaelem marad az elejn*/
	free(aktualis);							/*felszabadts*/

	if (m->bal) 							/*megnzzk. hogy van-e bal gyereke*/
	{
		seged=m->bal;
		if (seged->szamozas == 0)				/*megnezzuk, hogy a bal gyereket megltogattuk-e mr*/
		{
			seged->szamozas = ++kiosztott;			/*ha nem akkor megtesszk*/
									/*beszrjuk a bejrand elemek listjba*/
			aktualis= (struct listaelem *)malloc(sizeof(struct listaelem));		/*helyfoglals az j elemnek*/
			if(!aktualis)
			{
				printf("\Kevs a memria!\n");
				return -1;
			}
			aktualis->sorszam = seged->szamozas;		/*az j elem rtkeinak a belltsa*/
			aktualis->elem = seged;
			aktualis->kov = elso;
			utolso->kov = aktualis; utolso = aktualis;	/*mutatk lltsa*/
		}
	}
	if (m->jobb) 							/*megnzzk. hogy van-e jobb gyereke*/
	{
		seged=m->jobb;						/*megnezzuk, hogy a jobb gyereket megltogattuk-e mr*/
		if (seged->szamozas == 0)
		{
			seged->szamozas = ++kiosztott;			/*ha nem akkor megtesszk*/
			aktualis= (struct listaelem *)malloc(sizeof(struct listaelem));		/*helyfoglals az j elemnek*/
			if(!aktualis)					
			{
				printf("\Kevs a memria!\n");
				return -1;
			}
			aktualis->sorszam = seged->szamozas;		/*az j elem rtkeinak a belltsa*/
			aktualis->elem = seged;
			aktualis->kov = elso;
			utolso->kov = aktualis; utolso = aktualis;	/*mutatk lltsa*/	
		}
	}

	if (elso==elso->kov)							/*mr mindenhol jrtunk*/
	{

		return 0;						/*ezrt vge van*/
	}
	else 
	{
		aktualis = elso->kov;					/*a kvetkez bejrand csompont*/
		szelessegi_bejaras(aktualis->elem);			/*mg nem jrtunk mindenhol, ezrt megynk tovbb*/
	}

return 0;
} 
/*--------------------------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------------------------
	mlysgi bejaras
*/
int melysegi_bejaras(struct binaris *m)
{
	seged=m->bal;
	if (seged && (seged->szamozas == 0))				/*megnezzk, hogy van-e bal gyerek, s hogy jrtunk-e mr ott*/
	{								
		seged->szamozas = ++kiosztott;				/*ha nem akkor megtesszk*/
		kovetkezo = kiosztott;					/*belltjuk a kvetkez megltogattandt*/
		melysegi_bejaras(seged);				/*majd oda megyunk*/	
	}
	else
	{
		seged=m->jobb;
		if (seged && (seged->szamozas == 0))			/*megnezzk, hogy van-e jobb gyerek, s hogy jrtunk-e mr ott*/
		{								
			seged->szamozas = ++kiosztott;			/*ha nem akkor megtesszk*/
			kovetkezo = kiosztott;				/*belltjuk a kvetkez megltogattandt*/
			melysegi_bejaras(seged);			/*majd oda megyunk*/
		}
	}

	if (kovetkezo == 1)						/*mr mindenhol jrtunk*/
	{
		return 0;						/*ezrt vge van*/
	}
	else 
	{
		seged = m->szulo;			
		kovetkezo = seged->szamozas;
		melysegi_bejaras(seged);				/*mg nem jrtunk mindenhol, ezrt megynk tovbb*/
	}	

	return 0;
} 
/*--------------------------------------------------------------------------------------------*/



main()
{
	printf("\n\n");

	/*szelessgi bejaras*/	
	feltolt();
	
	elso= (struct listaelem *)malloc(sizeof(struct listaelem));
	if(!elso)
	{
		printf("\Kevs a memria!\n");
		return -1;
	}
	elso->elem=NULL;

	utolso= (struct listaelem *)malloc(sizeof(struct listaelem));
	if(!utolso)
	{
		printf("\Kevs a memria!\n");
		return -1;
	}
	utolso->kov=elso;
	utolso->elem=gyoker; utolso->sorszam=1;
	elso->kov=utolso;

	szelessegi_bejaras(gyoker);
	kiir(gyoker);


	/*melysegi bejaras*/	
	feltolt();
	melysegi_bejaras(gyoker);
	kiir(gyoker);



return 0;
}
