/*--------------------------------------------------------------------------------------------
	6_gyokmeghatarozas_intervallumfelezessel.c 

*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

enum sikeres  {nincs=0, van=1};

/* a vizsglt fggvny az x^3 + 1*/
double fgv(double x){
	return (x*x*x+1);
};

int felezo(double a, double b, double EPS, double *gyok)
{
	double x;			/* az intervallum kzept trolja*/
	double fx, fa;			/* a kzps s a bal oldali rtkhez tartoz fggvnyrtkeket trolja*/
	
	if ( fgv(a) * fgv(b) > 0)		return nincs;	/* megvizsgljuk, hogy a megadott hatrok*/
	else{							/* megfelelnek-e az elvrsoknak*/
	
		fa = fgv(a);			/* kiszmoljuk a fggvny rtkt az intervallum bal oldali pontjban*/

 		do
		{
			x = (a + b)/2;		/* az intervallum kzepnek a kiszmolsa*/
			fx = fgv(x);		/* kiszmoljuk a fggvny rtkt*/

			if (fx * fa > 0.0)	/* az eljel alapjn itt dl el, hogy*/
			{			/* melyik oldalrl szkitjk az intervallumot*/
				a = x;			
				fa = fx;
			}
			else b = x;

		
		}while (abs(fx) > EPS);
	
		*gyok = x;				/* a gyk rtkt a megfelel helyre rjuk*/
		return van;				/* visszatrnk*/ 
	}
}


void main()
{
	
	double *gyok=new double;
	printf("Gyokmeghatarozas intervallum felezessel , a fuggveny: y = x*x*x+1 \n");
	printf("A keresesi intervallum : [-2,10] \n\n");
	printf("Van megoldas? : %d \n", felezo(-2, 10, 0.00001, gyok) );
    	printf("A megoldas : %lf ",*gyok);
	delete gyok;

}
